package cn.iocoder.yudao.module.order.dal.mysql.orderLabel;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.order.dal.dataobject.orderLabel.OrderLabelDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.order.vo.orderLabel.*;

/**
 * 订单箱号标签 Mapper
 * @author 系统管理员
 */
@Mapper
public interface OrderLabelMapper extends AbstractMapper<OrderLabelDO> {
    @Override
    default PageResult<OrderLabelDO> selectPage(PageVO page, Object object) {
        if (object instanceof OrderLabelQueryVO) {
            OrderLabelQueryVO vo = (OrderLabelQueryVO)object;
            return selectPage(page, new LambdaQuery<OrderLabelDO>()
                .betweenIfPresent(OrderLabelDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                .eqIfPresent(OrderLabelDO::getOrderId, vo.getOrderId())
                .eqIfPresent(OrderLabelDO::getParentOrderId, vo.getParentOrderId())
                .eqIfPresent(OrderLabelDO::getStart, vo.getStart())
                .eqIfPresent(OrderLabelDO::getEnd, vo.getEnd())
                    .orderByDesc(OrderLabelDO::getId));
        }

        return null;
    }

    @Override
    default List<OrderLabelDO> selectList(Object object) {
        if (object instanceof OrderLabelQueryVO) {
            OrderLabelQueryVO vo = (OrderLabelQueryVO)object;
            return selectList(new LambdaQuery<OrderLabelDO>()
                .betweenIfPresent(OrderLabelDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                .eqIfPresent(OrderLabelDO::getOrderId, vo.getOrderId())
                .eqIfPresent(OrderLabelDO::getParentOrderId, vo.getParentOrderId())
                .eqIfPresent(OrderLabelDO::getStart, vo.getStart())
                .eqIfPresent(OrderLabelDO::getEnd, vo.getEnd())
                    .inIfPresent(OrderLabelDO::getOrderId, vo.getOrderIdList())
                    .orderByDesc(OrderLabelDO::getId));
        }

        return null;
    }
}
